#!/usr/bin/perl -w

# lwo.pl v0.1
# written by Risto Mki-Petays  <basscadet@iki.fi>
# 
# Just a simple Lightwave object loader. Works at least with Lightwave 7.0 and
# 8.0 objects. The code isn't very safe, use at your own risk!

use strict;
use File::stat;
use IO::File;

use LW;
use LW::Object;

my $x = new LW::Object;
if($x->open($ARGV[0])) {
  $x->report;
#  print $x->draw;
  my @gl_type = ("", "GL_POINTS", "GL_LINES", "GL_TRIANGLES", "GL_QUADS", "GL_POLYGON");
  foreach my $polygon ($x->getgl) {
    my $order = 0;
    if(@$polygon-1 < 5) {
      print $gl_type[@$polygon-1] . "\n";
    } else {
      print $gl_type[5] . "\n";
    }
    foreach my $vertex (@$polygon) {
      if($order++ == 0) {
        print "glNormal(@$vertex[0], @$vertex[1], @$vertex[2]);\n";
      } else {
        print "glVertex(@$vertex[0], @$vertex[1], @$vertex[2]);\n";
      }
    }
    print "\n";
  }
}

